package jp.naist.se.stigmata;

/*
 * $Id: BirthmarkElement.java 215 2007-09-25 09:04:12Z tama3 $
 */

import java.io.Serializable;

/**
 * element of birthmark.
 * 
 * @author  Haruaki TAMADA
 * @version  $Revision: 215 $ $Date: 2007-09-25 18:04:12 +0900 (Tue, 25 Sep 2007) $
 */
public class BirthmarkElement implements Serializable{
    private static final long serialVersionUID = 943675475343245243L;

    /**
     * element value.
     */
    private String value;

    /**
     * construct birthmark element with given value. 
     */
    public BirthmarkElement(String value) {
        this.value = value;
    }

    /**
     * return the value of this element.
     */
    public Object getValue(){
        return value;
    }

    /**
     * to string.
     */
    public String toString(){
        return String.valueOf(getValue());
    }

    /**
     * hash code for overriding equals method.
     */
    public int hashCode(){
        if(getValue() == null){
            return 0;
        }
        else{
            return getValue().hashCode();
        }
    }

    /**
     * equals method.
     */
    public boolean equals(Object o){
        if(o instanceof BirthmarkElement){
            if(getValue() != null){
                return getValue().equals(((BirthmarkElement)o).getValue());
            }
            else{
                return ((BirthmarkElement)o).getValue() == null;
            }
        }
        return false;
    }
}
