package jp.naist.se.stigmata.birthmarks.extractors;

/*
 * $Id: FrequencyMethodCallBirthmarkExtractorService.java 209 2007-09-23 13:13:59Z tama3 $
 */

import jp.naist.se.stigmata.BirthmarkExtractor;
import jp.naist.se.stigmata.birthmarks.fmc.FrequencyMethodCallBirthmarkExtractor;
import jp.naist.se.stigmata.spi.BirthmarkSpi;

/**
 * Birthmark Service Provider Interface.
 *
 * @author Haruaki TAMADA
 * @version $Revision: 209 $ $Date: 2007-09-23 22:13:59 +0900 (Sun, 23 Sep 2007) $
 */
public class FrequencyMethodCallBirthmarkExtractorService extends AbstractBirthmarkExtractorService{

    /**
     * returns a type of the birthmark this service provides.
     */
    public String getType(){
        return "fmc";
    }

    public String getExtractorClassName(){
        return "jp.naist.se.stigmata.birthmarks.fmc.FrequencyMethodCallBirthmarkExtractor";
    }

    /**
     * returns a extractor for the birthmark of this service.
     */
    public BirthmarkExtractor getExtractor(BirthmarkSpi service){
        return new FrequencyMethodCallBirthmarkExtractor(service);
    }
}